#ifndef COMMS_H
#define COMMS_H

#include <Arduino.h>

#define A000     (0)
#define A001     (1)
#define A002     (2)
#define A003     (3)
#define A004     (4)
#define A005     (5)
#define A006     (6)
#define A007     (7)
#define A008     (8)
#define A009     (9)
#define A010     (10)
#define A011     (11)
#define A012     (12)
#define A013     (13)
#define A014     (14)
#define A015     (15)
#define A016     (16)
#define A017     (17)
#define A018     (18)
#define A019     (19)
#define A020     (20)
#define A021     (21)
#define A022     (22)
#define A023     (23)
#define A024     (24)
#define A025     (25)
#define A026     (26)
#define A027     (27)
#define A028     (28)
#define A029     (39)

#define C000     A020
#define C001     A021
#define C002     A022
#define C003     A023
#define C004     A024
#define C005     A025
#define C006     A026
#define C007     A027
#define C008     A028
#define C009     A029

class PQ_LoRaWANClass 
{
public:
	int   begin(int device);
	bool joined();       // true == joined, false == non-joined
    bool busy();         // true == busy, false == ready
	void link();
    int   getNextTxTime();
	unsigned long getTimeOnAir() ;
	void sendMsg(uint8_t *buffer);
	void sendData(int *buffer, int length);

	void send(const char *buffer){sendMsg((uint8_t*)buffer);};
	void send(        char *buffer){sendMsg((uint8_t*)buffer);};
	void send(uint8_t     *buffer){sendMsg((uint8_t*)buffer);};
	
private:

};
	
class PQ_LoRaClass 
{
public:
	int   begin(int device);
	int   setRx(int device);
	int   setTx(int device, int power = 0);
	void link();
	uint8_t getStatus();
	void sendMsg(uint8_t *buffer);
	void sendData(int *buffer, int length);
	void sendCmd(int *buffer); //length == 2

	void send(const char *buffer){sendMsg((uint8_t*)buffer);};
	void send(        char *buffer){sendMsg((uint8_t*)buffer);};
	void send(uint8_t     *buffer){sendMsg((uint8_t*)buffer);};

private:

};

void receiveMsg(char *buffer, int length, int rssi, int snr) __attribute__((weak));
void receiveData(int *buffer, int length, int rssi, int snr) __attribute__((weak));
void receiveCmd(int *buffer, int length, int rssi, int snr) __attribute__((weak));

class CommunicationsClass {
public:
	PQ_LoRaWANClass LoRaWAN;
	PQ_LoRaClass        LoRa;
};

extern CommunicationsClass Communications;

//__attribute__((weak));


#endif 
