
#include "Arduino.h"
#include "GPS.h"

#include <TinyGPS++.h>

TinyGPSPlus _gps;

void _gps_putCharISR() {
  while (Serial1.available() > 0) {
    char ch = Serial1.read();
    if (_gps.encode(ch)) {
    }
    //DEBUG
    //Serial.print(ch);
  }
}

GPS::GPS()
{
  lat = 0;
  lon = 0;
  alt = 0;
  h  = 0;
  m  = 0;
  s  = 0;
}

void GPS::begin()
{
  //    _alarm_enable = false;
  Serial1.begin(9600);
  Serial1.onReceive(_gps_putCharISR);
  
  char configNav5[44]={0xB5,0x62,0x06,0x24,0x24,0x00,0xFF,0xFF,0x07,0x03,0x00,0x00,0x00,0x00,0x10,0x27,0x00,0x00,0x05,0x00,0xFA,0x00,0xFA,0x00,0x64,0x00,0x2C,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x17,0xFE};

  char configGalileu[68]={0xB5,0x62,0x06,0x3E,0x3C,0x00,0x00,0x00,0x20,0x07,0x00,0x08,0x10,0x00,0x01,0x00,0x01,0x01,0x01,0x01,0x03,0x00,0x01,0x00,0x01,0x01,0x02,0x04,0x08,0x00,0x01,0x00,0x01,0x01,0x03,0x08,0x10,0x00,0x00,0x00,0x01,0x01,0x04,0x00,0x08,0x00,0x00,0x00,0x01,0x01,0x05,0x00,0x03,0x00,0x01,0x00,0x01,0x01,0x06,0x08,0x0E,0x00,0x01,0x00,0x01,0x01,0x30,0xAD};
  
  char configSave[44]={0xB5,0x62,0x06,0x24,0x24,0x00,0xFF,0xFF,0x07,0x03,0x00,0x00,0x00,0x00,0x10,0x27,0x00,0x00,0x05,0x00,0xFA,0x00,0xFA,0x00,0x64,0x00,0x5E,0x01,0x00,0x3C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x85,0x2A};
  
  int i = 0;

  for(i=0;i<44;i++){
	Serial1.print(configNav5[i]);
 }
  for(i=0;i<68;i++){
	Serial1.print(configGalileu[i]);
 }
  for(i=0;i<44;i++){
	Serial1.print(configSave[i]);
 }
 
}

/*
   Get Functions
*/
bool GPS::ready()
{
  lat = 0;
  lon = 0;
  alt = 0;
  h  = 0;
  m  = 0;
  s  = 0;

  bool ret = false;

  if (_gps.time.isValid())
  {
    h = _gps.time.hour();
    m = _gps.time.minute();
    s = _gps.time.second();

    ret = true;
  }

  if (_gps.location.isValid() )
  {
    lat = _gps.location.lat();
    lon = _gps.location.lng();
    alt = _gps.altitude.meters();
    ret = true;
  }

  return true;

}

bool GPS::isFix(){
	return (_gps.location.isValid() && _gps.location.age() < 10000);
}

int GPS::getSeconds()
{
  return s;

}

int GPS::getMinutes()
{
  return m;
}

int GPS::getHours()
{
  return h;
}

float GPS::getLatitude()
{
  return lat;
}

float GPS::getLongitude()
{
  return lon;
}

int GPS::getAltitude()
{
  return alt;
}

int GPS::getLatitudeInt()
{
  return (int)lat;
}

int GPS::getLatitudeFrac()
{
  int lat_i = (int)lat;
  if (lat_i < 0) {
    return (int) ( (lat - lat_i) * (-10000.0) );
  } else {
    return (int) ( (lat - lat_i) * ( 10000.0) );
  }
}

int GPS::getLongitudeInt()
{
  return (int)lon;
}

int GPS::getLongitudeFrac()
{
  int lon_i = (int)lon;
  if (lon_i < 0) {
    return (int) ( (lon - lon_i) * (-10000.0) );
  } else {
    return (int) ( (lon - lon_i) * ( 10000.0) );
  }
}