
#include "PocketQube.h"

#include "Arduino.h"
#include "wiring_private.h"

#include <STM32L0.h>
#include <arduino.h>


void PocketQubeClass::init(){
	pinMode (PIN_LED_RED, OUTPUT);
	pinMode (PIN_LED_BLUE, OUTPUT);
	pinMode (PIN_LED_GREEN, OUTPUT);
	
	pinMode (PIN_BUTTON, INPUT);
	
	redOff();
	greenOff();
	blueOff();
	
	return;
}

uint64_t PocketQubeClass::getSerial()
{
    return STM32L0.getSerial();
}

void PocketQubeClass::getUID(uint32_t uid[3])
{
    return STM32L0.getUID(uid);
}

bool PocketQubeClass::getVBUS()
{
    return STM32L0.getVBUS();
}

float PocketQubeClass::getVBAT()
{
    return STM32L0.getVBAT();
}

float PocketQubeClass::getVDDA()
{
    return STM32L0.getVDDA();
}

float PocketQubeClass::getTemperature()
{
    return STM32L0.getTemperature();
}

uint32_t PocketQubeClass::resetCause()
{
    return STM32L0.resetCause();
}

void PocketQubeClass::wakeup()
{
    return STM32L0.wakeup();
}

void PocketQubeClass::sleep(uint32_t timeout)
{
    return STM32L0.sleep(timeout);
}

void PocketQubeClass::stop(uint32_t timeout)
{
    return STM32L0.stop(timeout);
}

void PocketQubeClass::standby()
{
    return STM32L0.standby();
}

void PocketQubeClass::standby(uint32_t pin)
{
    return STM32L0.standby(pin);
}

void PocketQubeClass::reset()
{
    return STM32L0.reset();
}

void PocketQubeClass::wdtEnable(uint32_t timeout)
{
    return STM32L0.wdtEnable(timeout);
}

void PocketQubeClass::wdtReset()
{
    return STM32L0.wdtReset();
}

void PocketQubeClass::blueOn() {
  digitalWrite(PIN_LED_BLUE, 0);
}
void PocketQubeClass::blueOff() {
  digitalWrite(PIN_LED_BLUE, 1);
}
void PocketQubeClass::redOn () {
  digitalWrite(PIN_LED_RED, 0);
}
void PocketQubeClass::redOff() {
  digitalWrite(PIN_LED_RED, 1);
}
void PocketQubeClass::greenOn() {
  digitalWrite(PIN_LED_GREEN, 0);
}
void PocketQubeClass::greenOff() {
  digitalWrite(PIN_LED_GREEN, 1);
}
bool PocketQubeClass::button() {
  return digitalRead(PIN_BUTTON);
}

PocketQubeClass PocketQube;