#ifndef POCKET_QUBE_H
#define POCKET_QUBE_H

/*----------------------------------------------------------------------------
 *        Headers
 *----------------------------------------------------------------------------*/ 
#ifdef __cplusplus

#include "PocketQube.h"
#include <Arduino.h>
#include <STM32L0.h>

#endif // __cplusplus

#ifdef __cplusplus
extern "C"
{
#endif // __cplusplus

class PocketQubeClass {
public:

	void init();

    uint64_t getSerial();
    void getUID(uint32_t uid[3]);

    bool  getVBUS();
    float getVBAT();
    float getVDDA();
    float getTemperature();

    uint32_t resetCause();

    void  wakeup();
    void  sleep(uint32_t timeout = 0);
    void  stop(uint32_t timeout = 0);
    void  standby();
    void  standby(uint32_t pin);
    void  reset();

    void  wdtEnable(uint32_t timeout);
    void  wdtReset();

	
	void blueOn();
	void blueOff();
	void redOn();
	void redOff();
	void greenOn();
	void greenOff();

	bool button();
};

extern PocketQubeClass PocketQube;

#ifdef __cplusplus
}
#endif

#endif